
$RESOURCE Project_Ico AS ".\_res\Project.ico"
$RESOURCE Form_Ico AS ".\_res\Form.ico"
$RESOURCE Bitmap_Ico AS ".\_res\Bitmap.ico"
$RESOURCE Button_Ico AS ".\_res\Button.ico"
$RESOURCE Check_Ico AS ".\_res\Check.ico"
$RESOURCE Combo_Ico AS ".\_res\Combo.ico"
$RESOURCE CoolBtn_Ico AS ".\_res\CoolBtn.ico"
$RESOURCE Dialog_Ico AS ".\_res\Dialog.ico"
$RESOURCE Edit_Ico AS ".\_res\Edit.ico"
$RESOURCE Frame_Ico AS ".\_res\Frame.ico"
$RESOURCE Gauge_Ico AS ".\_res\Gauge.ico"
$RESOURCE Image_Ico AS ".\_res\Image.ico"
$RESOURCE Label_Ico AS ".\_res\Label.ico"
$RESOURCE List_Ico AS ".\_res\List.ico"
$RESOURCE ListView_Ico AS ".\_res\ListView.ico"
$RESOURCE MainMenu_Ico AS ".\_res\MainMenu.ico"
$RESOURCE MenuItem_Ico AS ".\_res\MenuItem.ico"
$RESOURCE Option_Ico AS ".\_res\Option.ico"
$RESOURCE Panel_Ico AS ".\_res\Panel.ico"
$RESOURCE RichEdit_Ico AS ".\_res\RichEdit.ico"
$RESOURCE ScrollBar_Ico AS ".\_res\ScrollBar.ico"
$RESOURCE Slide_Ico AS ".\_res\Slide.ico"
$RESOURCE Splitter_Ico AS ".\_res\Splitter.ico"
$RESOURCE StatusBar_Ico AS ".\_res\StatusBar.ico"
$RESOURCE StringGrid_Ico AS ".\_res\StringGrid.ico"
$RESOURCE Tab_Ico AS ".\_res\Tab.ico"
$RESOURCE TreeView_Ico AS ".\_res\TreeView.ico"
$RESOURCE Enum_ico AS ".\_res\Enum.ico"
$RESOURCE UDT_ico AS ".\_res\UDT.ico"
$RESOURCE UDTCustom_ico AS ".\_res\UDTCustom.ico"
$RESOURCE UDTSub_ico AS ".\_res\UDTSub.ico"
$RESOURCE UDTFunc_ico AS ".\_res\UDTFunc.ico"
$RESOURCE Constructor_Ico AS ".\_res\Constructor.ico"
$RESOURCE Property_Ico AS ".\_res\Property.ico"
$RESOURCE Event_Ico AS ".\_res\Event.ico"
$RESOURCE Desconocido_Ico AS ".\_res\Desconocido.ico"

CONST TVM_SETITEMHEIGHT AS LONG =(&H1100 + 27)  'TV_FIRST + 27


DIM ImagenList AS QIMAGELIST
    ImagenList.AddICOHandle Project_Ico
    ImagenList.AddICOHandle Form_Ico
    ImagenList.AddICOHandle Bitmap_Ico
    ImagenList.AddICOHandle Button_Ico
    ImagenList.AddICOHandle Check_Ico
    ImagenList.AddICOHandle Combo_Ico
    ImagenList.AddICOHandle CoolBtn_Ico
    ImagenList.AddICOHandle Dialog_Ico
    ImagenList.AddICOHandle Edit_Ico
    ImagenList.AddICOHandle Frame_Ico
    ImagenList.AddICOHandle Gauge_Ico
    ImagenList.AddICOHandle Image_Ico
    ImagenList.AddICOHandle Label_Ico
    ImagenList.AddICOHandle List_Ico
    ImagenList.AddICOHandle ListView_Ico
    ImagenList.AddICOHandle MainMenu_Ico
    ImagenList.AddICOHandle MenuItem_Ico
    ImagenList.AddICOHandle Option_Ico
    ImagenList.AddICOHandle Panel_Ico
    ImagenList.AddICOHandle RichEdit_Ico
    ImagenList.AddICOHandle ScrollBar_Ico
    ImagenList.AddICOHandle Slide_Ico
    ImagenList.AddICOHandle Splitter_Ico
    ImagenList.AddICOHandle StatusBar_Ico
    ImagenList.AddICOHandle StringGrid_Ico
    ImagenList.AddICOHandle Tab_Ico
    ImagenList.AddICOHandle TreeView_Ico
    ImagenList.AddICOHandle Enum_ico
    ImagenList.AddICOHandle UDT_ico
    ImagenList.AddICOHandle UDTCustom_ico
    ImagenList.AddICOHandle UDTSub_ico
    ImagenList.AddICOHandle UDTFunc_ico
    ImagenList.AddICOHandle Constructor_Ico
    ImagenList.AddICOHandle Property_Ico
    ImagenList.AddICOHandle Event_Ico
    ImagenList.AddICOHandle Desconocido_Ico



CREATE ProjectTree AS QTREEVIEW
    Parent = LeftPanelBottomPanel
    Align = alClient
    ReadOnly = True
    Images = ImagenList
    Item(0).SelectedIndex = 0
    Indent = 6
    ShowButtons = True
    Hint = "Click to locate," + CRLF + "double click to edit"
    OnMouseDown = ProjectTree_MouseDown
'    OnExpanding = ProjectTree_Expand
'    OnCollapsing = ProjectTree_Collapse
    OnGetSelectedIndex = ProjectTree_OnGetSelectedIndex
    OnDblClick = ProjectTree_DblClick
    OnClick = ProjectTree_Click
    FullCollapse
END CREATE

SendMessage(ProjectTree.Handle , TVM_SETITEMHEIGHT , 22 , 0)        'set item heights



SUB ProjectTree_MouseDown(Button% , X% , Y% , Shift%)
    DIM a AS LONG
    IF Button% = 1 THEN                                             'be sure to set index for right click
        a = ProjectTree.GetItemAt(X% , Y%)
        ProjectTree.ItemIndex = a 
    END IF
END SUB


SUB ProjectTree_Click
    IF ProjectTree.ItemIndex > 0 THEN                               'no clicking on "<new form>"
        'get line # from combobox !!
        DEFSTR tmp = FIELD$(SubsCombo_objects.Item(ProjectTree.ItemIndex-1), LineNumDelimitr, 2)
        re.GotoLine(VAL(tmp))                                           'jump to that line
        re.ActiveLineColor(RGB(255,200,128), 0)                         'high light line
        IDE.HiLightTurnOFF = True                                       'toggle to turn off compile error line
        re.SetFocus
    END IF
END SUB


SUB ProjectTreeFullCollapse
    IF ProjectTree.Visible THEN ProjectTree.FullCollapse
END SUB

SUB ProjectTreeFullExpand
    IF ProjectTree.Visible THEN ProjectTree.FullExpand
END SUB



'SUB ProjectTree_Expand(index% , AllowExpansion%)
'    'If Index% = 0 then exit Sub
'    'ProjectTree.Item(Index%).ImageIndex = 2
'    'ProjectTree.Item(Index%).SelectedIndex = 2
'END SUB
'
'SUB ProjectTree_Collapse(index%)
'    'If Index% = 0 then exit Sub
'    'ProjectTree.Item(Index%).ImageIndex = 1
'END SUB


SUB ProjectTree_OnGetSelectedIndex(Index%)
    IF Index% <> 0 THEN ProjectTree.Item(Index%).SelectedIndex = ProjectTree.Item(Index%).ImageIndex
END SUB



SUB CleanFormDesignerCode
    IF Clipboard.Text <> "" THEN 
        tmpList.Clear
        tmpList.Text = Clipboard.text

        'tags to search for RQ code, these keep adding up
        'FRM_CODE 

        'tags to search for FreeBasic code
        ' FreeBasic code generated by RapidFRM

        'tags for all code, these are only returned on creation from RapidFRM, nice job Don H!!
        'FWD_DECL
        'FRM_STUBS

        DEFINT i
        FOR i = 0 TO tmpList.ItemCount -1

            IF UCASE$(TRIM$(LEFT$(tmpList.Item(i),9)))  = "'FRM_CODE" THEN tmpList.Item(i) = ""
            IF INSTR(TRIM$(UCASE$(tmpList.Item(i))), "FREEBASIC CODE GENERATED BY RAPIDFRM") THEN
                'insert new Freebasic file
                MFE_MakeNewFile("Form_Code.fbb")
                'set File type as FreeBasic
                IDE.LexLanguage(MFE_Tab.TabIndex) = SCLEX_FREEBASIC
                IDE.ModuleType(MFE_Tab.TabIndex) = 1       'FreeBasic module        
                re.SetFocus
                re.AddStrings(Clipboard.Text)
                Clipboard.Text = ""                 'reset this for return!!
                EXIT FOR
            END IF
        NEXT i
    END IF
END SUB


'---------   insert a form, simulate double click on ProjectTree   -------------
SUB IDE_InsertNewForm
    IF MFE_list.ItemCount = 0 THEN 
        MFE_MakeNewFile("Form_Code.bas")
        re.SetFocus
    END IF
    ProjectTree.ItemIndex = 0
    ProjectTree_DblClick
END SUB

'--------------------------------------------------------------------------------------------
' double click on ProjectTree means you want to edit the code in the visual designer
'--------------------------------------------------------------------------------------------

SUB ProjectTree_DblClick
    DEFSTR tmp = SubsCombo_objects.Item(ProjectTree.ItemIndex-1)        'get the text from the comboBox!
    DEFSTR tmp2 = ""
    DEFSTR FrmDesignerPath = ""

    IF FILEEXISTS(Application.Path + "\RapidFRM.exe" ) THEN 
        FrmDesignerPath = Quote$(Application.Path + "\RapidFRM.exe" ) + " clipboard"
    ELSE
        IF FILEEXISTS(Application.Path + "\tools\RapidFRM.exe" ) THEN 
            FrmDesignerPath = Quote$(Application.Path + "\tools\RapidFRM.exe" ) + " clipboard"
        END IF
    END IF

    IF FrmDesignerPath = "" THEN
        ShowMessage "Cannot find form designer" + CRLF + _
        "Place the file 'RapidFRM.exe' in the FreeQ IDEa path or tools folder"
        EXIT SUB
    END IF


    IF ProjectTree.ItemIndex = 0 THEN                               '"<new form>"
        tmp2 = Clipboard.Text
        tmpList.Clear
        DEFSTR s = IDE.CompilerTemplatePath + "qnew_application.tpl"

        IF FILEEXISTS(s) THEN 
            tmpList.LoadFromFile (s)
            'need to remove lines
            'SetWindowLong(Form.Handle, -8, 0)
            'SetWindowLong(Application.Handle, -8, Form.Handle)
            'Form.ShowModal

            DEFINT i
            FOR i = 0 TO tmpList.ItemCount -1
                IF UCASE$(TRIM$(LEFT$(tmpList.Item(i),14)))  = "SETWINDOWLONG(" THEN tmpList.Item(i) = "'" + tmpList.Item(i)
                IF INSTR(TRIM$(UCASE$(tmpList.Item(i))), ".SHOWMODAL") THEN tmpList.Item(i) = "'" + tmpList.Item(i)
            NEXT i

        ELSE
            tmpList.AddItems "CREATE Form AS QFORM"
            tmpList.AddItems "  Center"
            tmpList.AddItems "END CREATE"

        END IF

        Clipboard.Open
        Clipboard.Clear
        Clipboard.SetAsText tmpList.Text
        Clipboard.Close

        'can't edit text while in form designer
        CenterPanel.Visible = False
        re.Enabled = False
        SHELL FrmDesignerPath
        re.Enabled = True
        CenterPanel.Visible = True
        CleanFormDesignerCode
        IF Clipboard.Text <> "" THEN re.AddStrings (Clipboard.Text)
        Clipboard.Open
        Clipboard.Clear
        Clipboard.SetAsText tmp2
        Clipboard.Close
        LeftPanelRefresh                                               'update project explorer
        EXIT SUB
    END IF

    IF INSTR(UCASE$(tmp), "QFORM") THEN                                 'did we click on a QForm?
        DEFINT CreateStacks = 1                                         'stack counter of create.. end create
        DEFINT strt, ennd
        tmpList.Clear                                                   'this is the CREATE... END CREATE block to send to form designer

        'get line # from combobox !!
        DEFINT StrLine = VAL(FIELD$(SubsCombo_objects.Item(ProjectTree.ItemIndex-1), LineNumDelimitr, 2)) + 1
        re.GotoLine(StrLine)                                            'jump to that line
        strt = re.Position - LEN(re.Line(StrLine))                      'get start of selection
        tmpList.AddItems (re.Line(StrLine) - CRLF)

        IF StrLine <= re.LineCount THEN
            DO

                StrLine++
                re.GoToLine(StrLine)
                tmp2 = re.Line(StrLine) - CRLF
                tmpList.AddItems (tmp2)
                tmp2 = UCASE$(TRIM$(CleanComents(tmp2)))

                IF (LEFT$(tmp2, 4) = "END ") THEN                           'maybe found end create statement
                    IF INSTR(tmp2 , " CREATE") > 3 THEN                     'found it
                        CreateStacks--
                    END IF
                END IF

                IF (LEFT$(tmp2, 7) = "CREATE ") AND (INSTR(tmp2 , " AS ") > 8) THEN     'found a create statement
                    CreateStacks++
                END IF
            LOOP UNTIL (StrLine = re.LineCount) OR (CreateStacks = 0)
        END IF

        ennd = re.Position
        re.Set_AnchorPosition strt
        tmp2 = Clipboard.Text
        Clipboard.Open
        Clipboard.Clear
        Clipboard.SetAsText tmpList.Text
        Clipboard.Close

        'must turn off editing while in the form designer
        CenterPanel.Visible = False
        re.Enabled = False
        SHELL FrmDesignerPath
        re.Enabled = True
        CenterPanel.Visible = True
        CleanFormDesignerCode
        IF Clipboard.Text <> "" THEN re.Set_SelText Clipboard.Text
        Clipboard.Open
        Clipboard.Clear
        Clipboard.SetAsText tmp2
        Clipboard.Close
        LeftPanelRefresh            'must do this for next Double-Click
    END IF
END SUB


SUB Properties_Clear
    SubsCombo_objects.Clear 
    ProjectTree.Enabled = False
    ProjectTree.Visible = False
    ProjectTree.Clear
    ProjectTree.Enabled = True
    ProjectTree.Visible = True
    FOR zzz = 0 TO IDE_MAX_FILES
        IDE.ProjectTreeParsed(zzz) = False
    NEXT zzz
END SUB





SUB LoadProjectTree(indx AS INTEGER, SourceText AS STRING)
    IF (indx = -1) THEN EXIT SUB           'invalid file, need to check (SourceText = "")  ??
    IF IDE.ProjectTreeParsed(indx) = True THEN EXIT SUB

    DEFINT i,  ObjNamLoc, FindSubs = False
    DEFSTR myLine, TheObjName, TheQObjName, myDelimtr = SPACE$(45) + LineNumDelimitr
    SCREEN.Cursor = crHourGlass

    Stat.Panel(5).Caption = "Parsing file for objects"
    tmpList.Text = SourceText
    Properties_Clear
    ProjectTree.AddItems ("<new form at cursor>")
    DEFINT ProjParent = ProjectTree.ItemCount -1                    'should be 0 here

    FOR i = 0 TO tmpList.ItemCount - 1
        myLine = TRIM$(StripTabs(tmpList.Item(i)))                  '<-------------------------get new line
        myLine = CleanComents(myLine)                               '<----------Clean Comentaries
        '<may need to check for line continuation here>

        IF (LEFT$(UCASE$(myLine), 7) = "CREATE ") THEN              'maybe found a create statement
            ObjNamLoc = INSTR(UCASE$(myLine) , " AS ")              'get end location of object name
            IF ObjNamLoc > 8 THEN                                   'qobject is found
                TheObjName = TRIM$(MID$(myLine, 8, ObjNamLoc - 8))
                TheQObjName = TRIM$(MID$(myLine, ObjNamLoc + 4, LEN(myLine) - (ObjNamLoc + 3)))
                'now store the line (without CREATE) in the combo box, and give it a line #
                SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 7) + myDelimtr + STR$(i))

                IF INSTR(UCASE$(TheQObjName), "QFORM") THEN 
                    ProjectTree.AddItems (TheQObjName + "  (" + UCASE$(TheObjName) + ")")
                    ProjParent = ProjectTree.ItemCount - 1          'decrease one level down
                ELSE
                    IF ProjParent = 0 THEN                         'first object found
                        ProjectTree.AddItems (TheQObjName + "  (" + UCASE$(TheObjName) + ")")
                        ProjParent = ProjectTree.ItemCount -1       'decrease one level down
                    ELSE
                        ProjectTree.AddChildItems (ProjParent , TheQObjName + "  (" + UCASE$(TheObjName) + ")")
                    END IF
                END IF
                AddIco UCASE$(TheQObjName)
                ProjectTree.expand ProjParent , 0
            END IF
        END IF

        'Find : END CREATE
        IF (LEFT$(UCASE$(myLine), 4) = "END ") THEN              'maybe found end create statement
            IF INSTR(UCASE$(myLine) , " CREATE") > 4 THEN        'found it
                DEC ProjParent
            END IF
        END IF

        IF (LEFT$(UCASE$(myLine), 5) = "TYPE ") THEN                                'maybe found a UDT or custom component
            SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 5) + myDelimtr + STR$(i))
            ObjNamLoc = INSTR(UCASE$(myLine) , " EXTENDS ")

            IF ObjNamLoc > 5 THEN
                FindSubs = True 
                TheQObjName = TRIM$(MID$(UCASE$(myLine), 6, LEN(myLine) - 5))
                'ProjectTree.AddItems (TRIM$(MID$(myLine, 6, ObjNamLoc-6))+ "  (" + UCASE$(TheObjName) + ")")
                ProjectTree.AddItems (TheQObjName)
                ProjParent = ProjectTree.ItemCount -1       'decrease one level down
                AddIco UCASE$("UDTCUSTOM")
            ELSE
                TheQObjName = TRIM$(MID$(UCASE$(myLine), 6, LEN(myLine) - 5))
                ProjectTree.AddItems (TheQObjName + "  (UDT)")
                AddIco UCASE$("UDT")
            END IF
        END IF

        IF FindSubs = True THEN
            IF (LEFT$(UCASE$(myLine), 9) = "PROPERTY ") THEN              'maybe found a UDT or custom component
                TheQObjName = TRIM$(MID$(UCASE$(myLine), 9, LEN(myLine) - 8))
                SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 9) + myDelimtr + STR$(i))
                ProjectTree.AddChildItems (ProjParent , TheQObjName + "  (PROPERTY)")
                AddIco UCASE$("PROPERTY")
            END IF

            IF (LEFT$(UCASE$(myLine), 6) = "EVENT ") THEN              'maybe found a UDT or custom component
                TheQObjName = TRIM$(MID$(UCASE$(myLine), 6, LEN(myLine) - 5))
                SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 6) + myDelimtr + STR$(i))
                ProjectTree.AddChildItems (ProjParent , TheQObjName + "  (EVENT)")
                AddIco UCASE$("EVENT")
            END IF

            IF (TRIM$(UCASE$(myLine)) = "CONSTRUCTOR") THEN              'maybe found a UDT or custom component
                TheQObjName = "> Constructor"
                SubsCombo_objects.AddItems (TheQObjName + myDelimtr + STR$(i))
                ProjectTree.AddChildItems (ProjParent , TheQObjName ) '+ "  (CONSTRUCTOR)")
                AddIco UCASE$("CONSTRUCTOR")
            END IF

            IF (LEFT$(UCASE$(myLine), 4) = "SUB ") THEN              'sub in  a UDT or custom component
                TheQObjName = TRIM$(MID$(UCASE$(myLine), 4, LEN(myLine) - 3))
                SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 4) + myDelimtr + STR$(i))
                ProjectTree.AddChildItems (ProjParent , TheQObjName + "  (SUB)")
                AddIco UCASE$("UDTSUB")
            END IF

            IF (LEFT$(UCASE$(myLine), 9) = "FUNCTION ") THEN              'sub in  a UDT or custom component
                TheQObjName = TRIM$(MID$(UCASE$(myLine), 9, LEN(myLine) - 8))
                SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 9) + myDelimtr + STR$(i))
                ProjectTree.AddChildItems (ProjParent , TheQObjName + "  (FUNTION)")
                AddIco UCASE$("UDTFUNC")
            END IF

            IF (LEFT$(UCASE$(myLine), 4) = "END ") THEN              'maybe found end  statement
                IF INSTR(UCASE$(myLine) , " TYPE") > 3 THEN        'found it
                    DEC ProjParent
                    FindSubs = False
                END IF
            END IF

        END IF


        IF (LEFT$(UCASE$(myLine), 5) = "ENUM ") THEN              'maybe found a UDT or custom component
            TheQObjName = TRIM$(MID$(UCASE$(myLine), 6, LEN(myLine) - 5))
            SubsCombo_objects.AddItems (DELETE$(LTRIM$(tmpList.Item(i)), 1, 5) + myDelimtr + STR$(i))
            ProjectTree.AddItems (TheQObjName + "  (ENUM)")
            AddIco UCASE$("ENUM")
        END IF



'        'Find : END ENUM
'        IF (LEFT$(UCASE$(myLine), 4) = "END ") THEN              'maybe found end  statement
''            IF INSTR(UCASE$(myLine) , " ENUM") > 4 THEN        'found it
''                DEC ProjParent
''
''        'Find : END CONSTRUCTOR
''            ELSEIF INSTR(UCASE$(myLine) , " CONSTRUCTOR") > 4 THEN        'found it
''                DEC ProjParent
''
''        'Find : END EVENT
''            ELSEIF INSTR(UCASE$(myLine) , " EVENT") > 4 THEN        'found it
''                DEC ProjParent
''
''        'Find : END PROPERTY
''            ELSEIF INSTR(UCASE$(myLine) , " PROPERTY") > 4 THEN        'found it
''                DEC ProjParent
''
''        'Find : END PROPERTY
''            ELSEIF INSTR(UCASE$(myLine) , " PROPERTY") > 4 THEN        'found it
''                DEC ProjParent
''
'        'Find : END TYPE
'            IF INSTR(UCASE$(myLine) , " TYPE") > 3 THEN        'found it
''                DEC ProjParent
'                FindSubs = False
'
'        'Find : END CREATE
'            ELSEIF INSTR(UCASE$(myLine) , " CREATE") > 3 THEN        'found it
'                DEC ProjParent
'            END IF
'        END IF

    NEXT i


    tmpList.Text = ""
    subscombo_objects.ItemIndex = 0
    Stat.Panel(5).Caption = ""
    IF ProjectTree.ItemCount > 0 THEN
        ProjectTree.FullCollapse
        ProjectTree.Expand 0 , 0
    END IF
    SCREEN.Cursor = 0
    IDE.ProjectTreeParsed(indx) = True
END SUB




FUNCTION CleanComents(str AS STRING) AS STRING  'Delete all comments
    DIM Position AS INTEGER
    result = str  '<------------- Asume no coments in line
    Position = INSTR(str , "'") '<------------- search comment in the string
    IF Position > 0 THEN result = RTRIM$(LEFT$(str , Position - 1)) '<-----  If any, Clean it
END FUNCTION


SUB AddIco(Control AS STRING)
    SELECT CASE Control
        CASE "QFORM", "QFORMEX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 1
        CASE "QBITMAP", "QBITMAPEX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 2
        CASE "QBUTTON"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 3
        CASE "QCHECKBOX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 4
        CASE "QCOMBOBOX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 5
        CASE "QCOOLBTN"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 6
        CASE "QOPENDIALOG" , "QSAVEDIALOG", "QFILEDIALOG"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 7
        CASE "QEDIT"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 8
        CASE "QGROUPBOX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 9
        CASE "QGAUGE"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 10
        CASE "QIMAGE", "QIMAGEEX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 11
        CASE "QLABEL"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 12
        CASE "QLISTBOX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 13
        CASE "QLISTVIEW"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 14
        CASE "QMAINMENU"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 15
        CASE "QMENUITEM"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 16
        CASE "QRADIOBUTTON"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 17
        CASE "QPANEL"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 18
        CASE "QRICHEDIT", "QRICHEDITEX"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 19
        CASE "QSCROLLBAR"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 20
        CASE "QSLIDE"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 21
        CASE "QSPLITTER"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 22
        CASE "QSTATUSBAR"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 23
        CASE "QSTRINGGRID"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 24
        CASE "QTABCONTROL"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 25
        CASE "QTREEVIEW"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 26
        CASE "ENUM"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 27
        CASE "UDT"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 28
        CASE "UDTCUSTOM"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 29
        CASE "UDTSUB"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 30
        CASE "UDTFUNC"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 31
        CASE "CONSTRUCTOR"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 32
        CASE "PROPERTY"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 33
        CASE "EVENT"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 34
        CASE "EVENT"
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 35
        CASE ELSE
            ProjectTree.Item(ProjectTree.ItemCount - 1).ImageIndex = 36
    END SELECT
END SUB
